﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Outlook = Microsoft.Office.Interop.Outlook

'Add-in Express Add-in Module
<GuidAttribute("9D908E46-60AA-4EE6-8917-B39FC7FED173"), ProgIdAttribute("adx_ol_vb_events.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents adxOutlookEvents As AddinExpress.MSO.ADXOutlookAppEvents

    Dim itemEvents As OutlookItemEvents

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer
 
    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.adxOutlookEvents = New AddinExpress.MSO.ADXOutlookAppEvents(Me.components)
        '
        'adxOutlookEvents
        '
        '
        'AddinModule
        '
        Me.AddinName = "adx_ol_vb_events"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub
 
#End Region
 
#Region " Add-in Express automatic code "
 
    'Required by Add-in Express - do not modify
    'the methods within this region
 
    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function
 
    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub
 
    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub
 
    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub
 
#End Region
 
    Public Sub New()
        MyBase.New()
 
        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()
 
        'Please add any initialization code to the AddinInitialize event handler
 
    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return CType(HostApplication, Outlook._Application)
        End Get
    End Property

    Private Sub AddinModule_AddinStartupComplete(sender As System.Object, e As System.EventArgs) Handles MyBase.AddinStartupComplete
        itemEvents = New OutlookItemEvents(Me)
    End Sub


    Private Sub AddinModule_AddinBeginShutdown(sender As System.Object, e As System.EventArgs) Handles MyBase.AddinBeginShutdown
        ' in Outlook 2010, this event may not occur, see the blog 'Outlook 2010 Fast Shutdown feature'
        ' at http://www.add-in-express.com/creating-addins-blog/2010/05/04/outlook2010-fast-shutdown/

        If itemEvents.IsConnected Then
            itemEvents.RemoveConnection()
        End If
        itemEvents = Nothing
    End Sub

    Private Sub adxOutlookEvents_InspectorActivate(sender As System.Object, inspector As System.Object, folderName As System.String) Handles adxOutlookEvents.InspectorActivate
        Dim itemObj As Object = (TryCast(inspector, Outlook._Inspector)).CurrentItem
        ' Now itemObj contains a COM object holding the Outlook item shown in the active inspector.
        ' Creating a COM object implies releasing it as soon as you don't need it! See how we deal with this.

        ' use late binding to retrieve the Subject property of the item
        Dim subject As String = "'" & itemObj.GetType().InvokeMember("Subject", System.Reflection.BindingFlags.GetProperty, Nothing, itemObj, Nothing).ToString() & "'"
        Marshal.ReleaseComObject(itemObj)

        If itemEvents.IsConnected Then
            itemEvents.RemoveConnection()
        End If

        If GetExplorersCount() > 0 Then ' don't connect if there are NO open explorers
            ' We handle all Outlook item types: MailItem, TaskItem, etc.
            ' 'True' means the events class will release the COM object holding a reference to the item shown 
            ' in the active inspector when itemEvents.RemoveConnection is called (see the code line above).
            ' Note that calling CurrentItem several times creates several COM objects, each of them must be released.
            itemEvents.ConnectTo((TryCast(inspector, Outlook._Inspector)).CurrentItem, True)
        End If
    End Sub

    Private Function GetExplorersCount() As Integer
        Dim count As Integer = 0
        Dim expls As Outlook._Explorers = Nothing

        Try
            expls = OutlookApp.Explorers
            count = expls.Count
        Catch
        Finally
            If expls IsNot Nothing Then
                Marshal.ReleaseComObject(expls)
            End If
        End Try
        Return count
    End Function

    Private Sub adxOutlookEvents_InspectorClose(sender As System.Object, inspector As System.Object, folderName As System.String) Handles adxOutlookEvents.InspectorClose
        If itemEvents.IsConnected Then
            itemEvents.RemoveConnection()
        End If
    End Sub
End Class

